SystemOrganization addCategory: #'JQueryMobile-Core-Configuration'!

WASystemConfiguration subclass: #JQMConfigurator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Core-Configuration'!

!JQMConfigurator class methodsFor: 'defaults' stamp: 'NickAger 9/19/2012 08:21'!
defaultFileLibrary 
	^ JQM111LocalDeploymentLibrary! !

!JQMConfigurator methodsFor: 'description' stamp: 'NickAger 9/9/2012 19:45'!
describeOn: config
	(config list: #jqmFileLibrary)
		group: #jqueryMobile;
		options: [ self fileLibraries ];
		comment: 'Choose from local/CDN hosted urls and development or minimized deployment libraries';
		default: self class defaultFileLibrary! !

!JQMConfigurator methodsFor: 'accessing' stamp: 'NickAger 9/19/2012 08:22'!
fileLibraries
	^ Array
		with: JQM111LocalDeploymentLibrary
		with: JQM111LocalDevelopmentLibrary
		with: JQM111DeploymentLibrary
		with: JQM111DevelopmentLibrary
		with: JQMDailyBuildsLibrary
		with: JQM111LocalDevelopmentWithTransitionFixesLibrary ! !

!WAApplication methodsFor: '*jquerymobile-core-configuration' stamp: 'NickAger 9/9/2012 19:34'!
jqmFileLibrary
	| jqmFileLibrary |
	
	[
		"Note: with Seaside 3.1 this can be simplified by using the method #preferenceAt:ifAbsent: "
		jqmFileLibrary := self preferenceAt: #jqmFileLibrary ]
		on: WAAttributeNotFound
		do: [ :err |
			WAError signal: 'JQuery Mobile now includes a configuration (JQMConfigurator) which allows you to specify the file library to use. However the JQM configuration is not setup for this application. Re-register the application with JQMAdmin class>>#register:ApplicationAt: and this exception will not occur.' ].
		
	^ jqmFileLibrary default "return instance"! !

!GRPackage class methodsFor: '*jquerymobile-core-configuration' stamp: 'NickAger 9/9/2012 21:17'!
jQueryMobileCoreConfiguration
	^ self new
		name: 'JQueryMobile-Core-Configuration';
		description: 'jQueryMobile configuration';
		addDependency:  'JQueryMobile-Libraries';
		url: #seasideUrl;
		yourself! !
